diff -uNr 3.5/source/conline/line/laub.f unipops-3.6/source/conline/line/laub.f
--- 3.5/source/conline/line/laub.f	2000-03-16 11:34:59.000000000 -0700
+++ unipops-3.6/source/conline/line/laub.f	2008-12-29 14:39:25.000000000 -0700
@@ -17,7 +17,9 @@
       real*4 df, bm, sm, atemp, toff, off, diff, ton, pr1,
      .		tsyson, tsysoff, f, scanno, rinfinity, ref(MAX_DATA_POINTS)
       character*1 losgn
-      real*8 dsmbm(3), nrao140, nrao300, t12m, dinfinity, specproc 
+      real*8 dsmbm(3), dinfinity, value12m,value140,value300,valuespec,
+     .     valuesmt
+      character*8 nrao140, nrao300, t12m, specproc, smt
       character*24 csmbm
       CHARACTER*80 CPUF
       character*60 errstr
@@ -29,10 +31,17 @@
 c
       EQUIVALENCE (CPUF,IPUF)
       equivalence (csmbm, dsmbm)
+c     we need these equivalences, because g77 can't declare chars as reals
+c     (ex. NRAO declared t12m as a real*8; we have to have it as char*8)
+      equivalence (t12m, value12m)
+      equivalence (nrao140, value140)
+      equivalence (nrao300, value300)
+      equivalence (smt, valuesmt)
+      equivalence (specproc,valuespec)
 c
       DATA IHOLD /3/, ITEMP /2/
       data t12m/'NRAO 12M'/,nrao140/'NRAO 43M'/,nrao300/'NRAO 93M'/
-      data specproc/'SPECPROC'/
+      data specproc/'SPECPROC'/,smt/'ARO-HHT'/
       data n283/283/, m2/-2/, n120/120/, m3/-3/, n291/291/, n247/247/,
      .	   n112/112/, m1/-1/, n225/225/, n221/221/, n222/222/
 c
@@ -47,10 +56,11 @@
 C						RAP
 C----------------------------------------------------------------------
   170 CONTINUE
-      if(dtwh(c1tel,iptwh).eq.t12m) then
+      if(dtwh(c1tel,iptwh).eq.value12m .or. 
+     .   dtwh(c1tel,iptwh).eq.valuesmt) then
 	goto 1709
-      else if(dtwh(c1tel,iptwh).eq.nrao140 .or. 
-     1	      dtwh(c1tel,iptwh).eq.nrao300) then
+      else if(dtwh(c1tel,iptwh).eq.value140 .or. 
+     1	      dtwh(c1tel,iptwh).eq.value300) then
 	goto 1719
       else
         call oerror(n283, m2, 'RAP')
@@ -145,7 +155,7 @@
       if (ierr .ne. 0) call oerror(n247, m2, "RAP")
 c     Create Reference Spectra
 c
-      if (dtwh(c1bke,iptwh).eq. specproc) then
+      if (dtwh(c1bke,iptwh).eq. valuespec) then
         tsyson = dTWH(c12rst,IPTWH)
         tsysoff = sqrt( (dTWH(c12sst,IPTWH)**2)*2. - tsyson**2 )
       else
@@ -208,10 +218,11 @@
 c  Green Bank: (0) = ON  (1) = OFF
 C ------------------------------------------------------------------
   300 CONTINUE
-      if(dtwh(c1tel,iptwh).eq.nrao140.or.
-     1   dtwh(c1tel,iptwh).eq.nrao300) then
+      if(dtwh(c1tel,iptwh).eq.value140.or.
+     1   dtwh(c1tel,iptwh).eq.value300) then
 	goto 3021
-      else if(dtwh(c1tel,iptwh).eq.t12m) then
+      else if(dtwh(c1tel,iptwh).eq.value12m .or.
+     .        dtwh(c1tel,iptwh).eq.valuesmt) then
 	goto 3001
       else
 	call oerror(n283, m2, 'TEMP')
@@ -268,7 +279,7 @@
 c     Update all necessary header parameters (see memo by R.Maddalena
 c	dated Jan 22, 1992).
 c
-      if (dtwh(c1bke,iptwh).eq. specproc) then
+      if (dtwh(c1bke,iptwh).eq. valuespec) then
 	tsyson = tsysoff
 	istart = istart + 1
 	istop = istop - 1
diff -uNr 3.5/source/conline/line/lpdoc.f unipops-3.6/source/conline/line/lpdoc.f
--- 3.5/source/conline/line/lpdoc.f	2000-03-16 11:35:19.000000000 -0700
+++ unipops-3.6/source/conline/line/lpdoc.f	2008-12-29 14:39:27.000000000 -0700
@@ -1,14 +1,13 @@
       SUBROUTINE pdoc(ifit)
 C-----------------------------------------------------------------------
 C @(#)lpdoc.f	5.3 09/10/98
-C
 C-----------------------------------------------------------------------
       integer*2 ipos(4), jpos(4), lstrng(6), dstrng(5), gstrng(5),
-     .          str1(4), str2(4), ichsize, ifit, ier, imon, iday, iyr,
+     .          str1(4), str2(4), ichsize, ifit, imon, iday, iyr,
      .          il1, il2, il3, lastblnk
       integer*4 IM(3), IS(3), JM(3), JS(3), iptwh, nn, i, iazof, 
      .          ielof, iscan, ifb, itm, its, ihp, ns, isb, nloffset, 
-     .          plen, ifeed
+     .          plen, ifeed, ier
       integer*2 m2, n0, n1, n3, n72, n80, n234, n352, n355, n356
       integer*2 n25, n50, n75, n275, n300, n325, n450, n475, n500,
      .          n625, n650, n675, n700, n725, n750, n775, n800
@@ -23,7 +22,7 @@
       real*8 pt_model, rx_info(2)
       character*8 cpt_model
       character*16 crx_info
-      character*1 ipl, ipr(3), jpr(3), ic(4), imu
+      character*1 ipl, ipr(3), jpr(3), ic(4), imu, tempchar
       character*1023 pfile
 c
       INCLUDE 'appl.inc'
@@ -66,10 +65,10 @@
 c
       OBSOPR=DTWH(C1OBS,IPTWH)
       AZOF=DTWH(C2UXP,IPTWH)
-      IAZOF=IFIX(AZOF+SIGN(0.5,AZOF))
+      IAZOF=int(AZOF+SIGN(0.5,AZOF))
       AZOF=FLOAT(IAZOF)
       ELOF=DTWH(C2UYP,IPTWH)
-      IELOF=IFIX(ELOF+SIGN(0.5,ELOF))
+      IELOF=Int(ELOF+SIGN(0.5,ELOF))
       ELOF=FLOAT(IELOF)
       LST=DTWH(C3LST,IPTWH)
       CALL RNS(LST,n0,LSTRNG)
@@ -78,7 +77,7 @@
       ITS=nint(DTWH(C12SST,IPTWH))
       IFB=nint(abs(DTWH(C12FR,IPTWH)*1000.0))
       hp = dtwh(c7fw, iptwh)
-      IHP=IFIX(HP+0.5)
+      IHP=Int(HP+0.5)
       NS=DTWH(C12IT,IPTWH)/DTWH(C3SRT,IPTWH)
       DAT=DTWH(C3DAT,IPTWH)
       CALL UDAT(DAT,IMON,IDAY,IYR)
@@ -227,10 +226,10 @@
       CAZ=CAZ+CAZZ(NN)
       CELL(NN)=ELOF+(2.0-CG(1))*HP
       CEL=CEL+CELL(NN)
-      IPOS(NN*2-1)=510+IFIX((5.0-CG(3))*182.+0.5)
-      JPOS(NN*2-1)=475+IFIX((2.0-CG(1))*175.+0.5)
-      IPOS(NN*2)=510+IFIX((5.0-CG(4))*182.+0.5)
-      JPOS(NN*2)=475+IFIX((2.0-CG(2))*175.+0.5)
+      IPOS(NN*2-1)=510+INT((5.0-CG(3))*182.+0.5)
+      JPOS(NN*2-1)=475+INT((2.0-CG(1))*175.+0.5)
+      IPOS(NN*2)=510+INT((5.0-CG(4))*182.+0.5)
+      JPOS(NN*2)=475+INT((2.0-CG(2))*175.+0.5)
 c
       IF (IFIT.EQ.NN) GO TO 250
 c
@@ -244,13 +243,13 @@
 C
   250 DO 253 I = 1,NN
          ACAZ=ABS(CAZZ(I))
-         IM(I)=IFIX(ACAZ/60.)
-         IS(I)=IFIX(ACAZ-FLOAT(IM(I))*60.+0.5)
+         IM(I)=INT(ACAZ/60.)
+         IS(I)=INT(ACAZ-FLOAT(IM(I))*60.+0.5)
          IPR(I)=IPL
          IF (CAZZ(I).LT.0.0) IPR(I)=IMU
          ACEL=ABS(CELL(I))
-         JM(I)=IFIX(ACEL/60.0)
-         JS(I)=IFIX(ACEL-FLOAT(JM(I))*60.0+0.5)
+         JM(I)=INT(ACEL/60.0)
+         JS(I)=INT(ACEL-FLOAT(JM(I))*60.0+0.5)
          JPR(I)=IPL
          IF (CELL(I).LT.0.0) JPR(I)=IMU
   253 CONTINUE
@@ -258,14 +257,14 @@
       if (IFIT.EQ.2) then
          CAZ=CAZ/NN
          ACAZ=ABS(CAZ)
-         IM(3)=IFIX(ACAZ/60.)
-         IS(3)=IFIX(ACAZ-FLOAT(IM(3))*60.+0.5)
+         IM(3)=INT(ACAZ/60.)
+         IS(3)=INT(ACAZ-FLOAT(IM(3))*60.+0.5)
          IPR(3)=IPL
          IF (CAZ.LT.0.0) IPR(3)=IMU
          CEL=CEL/NN
          ACEL=ABS(CEL)
-         JM(3)=IFIX(ACEL/60.0)
-         JS(3)=IFIX(ACEL-FLOAT(JM(3))*60.0+0.5)
+         JM(3)=INT(ACEL/60.0)
+         JS(3)=INT(ACEL-FLOAT(JM(3))*60.0+0.5)
          JPR(3)=IPL
          IF (CEL.LT.0.0) JPR(3)=IMU
          WRITE (CPUF,4013,IOSTAT=IER) 
@@ -291,17 +290,21 @@
       endif
       write(cpuf, 4017, iostat=ier) pfile(max(1,plen-71):plen)
       call pwrite(cpuf, n80)
-      open (unit=iiotmp,file=pfile, status='old', fileopt='eof',
-     .      iostat = ier)
-      if (ier .ne. 0) then
+c     g77 cant do fileopt=eof, so we'll seek there ourselves
+      open (unit=iiotmp,file=pfile, status='old', iostat = ier)
+      do while (.true.)
+         read (iiotmp, end=100, fmt='(A1)') tempchar
+      end do
+c     should be at EOF now
+ 100  if (ier .ne. 0) then
          call oerror(n352, n0, 'POINT.DAT')
 c
       else
          FRQ=DTWH(C12RF,IPTWH)*0.001
          UT=DTWH(C3UT,IPTWH)
          CALL RNS (UT,n0,LSTRNG)
-         IHP=IFIX(HP+0.5)
-         IFEED = ifix ((dtwh(c1sno,iptwh) - float(iscan)) * 100. + 0.5) 
+         IHP=int(HP+0.5)
+         IFEED = int ((dtwh(c1sno,iptwh) - float(iscan)) * 100. + 0.5) 
 c
 c  Compute the total change in new pointing correction from the
 c  initial guess (PRJ  25 Jul 91):
diff -uNr 3.5/source/conline/line/mheader.f unipops-3.6/source/conline/line/mheader.f
--- 3.5/source/conline/line/mheader.f	2000-03-16 11:35:06.000000000 -0700
+++ unipops-3.6/source/conline/line/mheader.f	2008-12-29 14:39:26.000000000 -0700
@@ -4,9 +4,9 @@
 c
 c     Lists out the contents of the header of the IPTWH matrix
 c
-      integer*2 iptwh, istch(40), ierr, n, iinitp, n1
+      integer*2 iptwh, istch(40), n, iinitp, n1
       integer*2 m2, n80, n112
-      integer*4 n24, nchar
+      integer*4 n24, nchar, ierr
       character*80 stch
       character*24 sdate
 c
diff -uNr 3.5/source/conline/line/minit.f unipops-3.6/source/conline/line/minit.f
--- 3.5/source/conline/line/minit.f	2000-03-16 11:35:07.000000000 -0700
+++ unipops-3.6/source/conline/line/minit.f	2008-12-29 14:39:26.000000000 -0700
@@ -13,8 +13,8 @@
       include 'mappl.inc'
       include 'mform.inc'
 c
-      integer*2 i,lastblnk,ierr, nx, ny, j1
-      integer*4 n0, n24, n80, nchars, datestyle
+      integer*2 i,lastblnk, nx, ny, j1
+      integer*4 n0, n24, ierr, n80, nchars, datestyle
       character*80 input, fmts, fmtf, fmtd1, fmtd2
       character*24 sdate
       real*8 ddate
diff -uNr 3.5/source/conline/line/mlabel.f unipops-3.6/source/conline/line/mlabel.f
--- 3.5/source/conline/line/mlabel.f	2000-03-16 11:35:10.000000000 -0700
+++ unipops-3.6/source/conline/line/mlabel.f	2008-12-29 14:39:26.000000000 -0700
@@ -4,13 +4,13 @@
 C
 c     Draws a labeled and anotated box for the previous 2-dim map
 c
-      integer*2 itype, ix, iy, sclc, ipixel, istch(40), i, j, ier, 
+      integer*2 itype, ix, iy, sclc, ipixel, istch(40), i, j,
      .		numlevs, ierr, idelx, idely, ilen, lastblnk, short,
      .		imintmp, imaxtmp, jmintmp, jmaxtmp, curcur
       integer*2 n1, n8, m2, m1
       integer*2 n2, n5, n10, n12, n14, n18, n20, n30, n38, n40,
      .          n55, n90, n100, n125, n272
-      integer*4 l2, l34, l80
+      integer*4 l2, l34, l80, ier
       integer*4 iby, ibx, nchars
       real xlft, xrght, ybot, ytop, xf, xl, dx, yf, yl, dy, xz, yz,
      .	   percents(34), value, aindex, blah(2,34), axtmp, aytmp, 
diff -uNr 3.5/source/conline/line/mread.f unipops-3.6/source/conline/line/mread.f
--- 3.5/source/conline/line/mread.f	2000-03-16 11:35:12.000000000 -0700
+++ unipops-3.6/source/conline/line/mread.f	2008-12-29 14:39:26.000000000 -0700
@@ -10,7 +10,7 @@
       character*1023 headname, fullname
       character*1 quote
       logical lend, inquirefile, okreal4, okreal8
-      integer*4 n1, n2, long, i4, nwrds1, nwrds2, nwrds4, nwrds8, nwrds,
+      integer*4 n1, n2, i4, nwrds1, nwrds2, nwrds4, nwrds8, nwrds,
      +          l80, nchars, oldfits
 c
       parameter (nwrds1 = 2880)
@@ -18,9 +18,9 @@
       parameter (nwrds4 = 720)
       parameter (nwrds8 = 360)
 c
-      integer*2 ierr, j, i, k, lastblnk, ilen, irec, nv, numhead, kmax, 
+      integer*2 j, i, k, lastblnk, ilen, irec, nv, numhead, kmax, 
      .		maxrec, mleft, ldata2(nwrds2), istch(40)
-      integer*4 ldata4(nwrds4), iblank, ii
+      integer*4 ierr, ldata4(nwrds4), iblank, ii
       integer*2 m1, m2, n80, n352, n357, n365
       character*1 cdata1(nwrds1)
       real tzero, tscale, rdata4(nwrds4), fblank, r_quiet_nan
@@ -44,7 +44,7 @@
       call filecomp(filename, fullname)
 c
       ilen = lastblnk(dirprefix(1))
-      headname = dirprefix(1)(1:ilen) // '/sunbin/twodim.mask'
+      headname = dirprefix(1)(1:ilen) // '/bin/twodim.mask'
 c     Get the file name of FITS template file
 c
       open(unit=iiotmp,file=headname,access='sequential',
@@ -200,16 +200,16 @@
                 endif
 		if (i .eq. 20) cmhead(mbunit,1) = head(j) (12:19) 
 c
-      		if (i.eq.7) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i.eq.7) read(head(j)(11:30),40,iostat=ierr) 
      .							mhead(mrval1,1)
-      		if (i.eq.8) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i.eq.8) read(head(j)(11:30),40,iostat=ierr) 
      .							mhead(mdelt1,1)
-		if (i.eq.9) read(unit=head(j)(11:30),40) mhead(mpix1,1)
-      		if (i .eq. 11) read(unit=head(j)(11:30),40,iostat=ierr) 
+		if (i.eq.9) read(head(j)(11:30),40) mhead(mpix1,1)
+      		if (i .eq. 11) read(head(j)(11:30),40,iostat=ierr) 
      .							mhead(mrval2,1)
-      		if (i .eq. 12) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i .eq. 12) read(head(j)(11:30),40,iostat=ierr) 
      .							mhead(mdelt2,1)
-		if (i .eq. 13) read(unit=head(j)(11:30),40,iostat=ierr) 
+		if (i .eq. 13) read(head(j)(11:30),40,iostat=ierr) 
      .							mhead(mpix2,1)
       		if (i .eq. 17) then
 c                           look for bad unipops BLANK values which are
@@ -219,17 +219,17 @@
                       if (head(j)(ii:ii) .eq. '.') goto 410
  405               continue
  410               if (ii .le. 30) then
-                      read(unit=head(j)(11:30),40,iostat=ierr) fblank
+                      read(head(j)(11:30),40,iostat=ierr) fblank
                    else
-                      read(unit=head(j)(15:30),45,iostat=ierr) iblank
+                      read(head(j)(15:30),45,iostat=ierr) iblank
                       fblank = iblank
                    endif
                 endif
-      		if (i .eq. 18) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i .eq. 18) read(head(j)(11:30),40,iostat=ierr) 
      .							tscale
-      		if (i .eq. 19) read(unit=head(j)(11:30),40,iostat=ierr)
+      		if (i .eq. 19) read(head(j)(11:30),40,iostat=ierr)
      .							tzero
-      		if (i .eq. 23) read(unit=head(j) (11:30),40,iostat=ierr) 
+      		if (i .eq. 23) read(head(j)(11:30),40,iostat=ierr) 
      .							mhead(mequinox,1)
  40             format(1p1g20.0)
  45             format(i16)
@@ -302,7 +302,7 @@
 c	into the matrix.
 c
 	do 91 i = 1, j
-	   i4 = long(i) + nwrds*long(irec-numhead-1)
+	   i4 = int(i) + nwrds*int(irec-numhead-1)
 	   if (nint(mhead(mbitpix,1)) .eq. 16) then
 	   	if (ldata2(i) .eq. fblank) then
 			mdata(i4) = mhead(mblank,1)
diff -uNr 3.5/source/conline/line/mtable.f unipops-3.6/source/conline/line/mtable.f
--- 3.5/source/conline/line/mtable.f	2000-03-16 11:35:16.000000000 -0700
+++ unipops-3.6/source/conline/line/mtable.f	2008-12-29 14:39:26.000000000 -0700
@@ -17,12 +17,12 @@
 c
 c
       real z(isize,jsize)
-      integer*4 isize, jsize
+      integer*4 isize, jsize, ierr
 c
       include 'mappl.inc'
 c
       integer*2 m2, n80, n254
-      integer*2 npages, n1, n2, np, j, j1, istch(40), ierr, i
+      integer*2 npages, n1, n2, np, j, j1, istch(40), i
       character*80 stch
 c
       equivalence(istch, stch)
diff -uNr 3.5/source/conline/line/mwrite.f unipops-3.6/source/conline/line/mwrite.f
--- 3.5/source/conline/line/mwrite.f	2000-03-16 11:35:16.000000000 -0700
+++ unipops-3.6/source/conline/line/mwrite.f	2008-12-29 14:39:27.000000000 -0700
@@ -9,23 +9,23 @@
       character*24 sdate
       character*80 hmask(36), stch
       character*1023 headname, fullname
-      integer*4 n1, n2, unlink, nwrds2, i4, long, hcmt, nwrds4, nwrds,
-     .          nwrds1, nwrds8, n24, nchars, nend
+      integer*4 n1, n2, unlink, nwrds2, i4, hcmt, nwrds4, nwrds,
+     .          nwrds1, nwrds8, n24, nchars, nend, ierr
 c
       parameter (nwrds1 = 2880)
       parameter (nwrds2 = 1440)
       parameter (nwrds4 = 720)
       parameter (nwrds8 = 360)
 c
-      integer*2 ierr, ilen, lastblnk, i, j, ldata2(nwrds2), maxrec,  
+      integer*2 ilen, lastblnk, i, j, ldata2(nwrds2), maxrec,  
      .		mleft, irec, istch(40), ixmin, iymin, ixmax, iymax, 
      .		blankfits2, blankfits1
       integer*4 ldata4(nwrds4), blankfits4
       integer*2 m1, m2, n0, n80, n255, n273, n352, n355, n357, n366
       real value, zmin, zmax, tscale, tzero, rdata4(nwrds4),
-     .     rnan, r_quiet_nan
+     .     rnan, r_quiet_nan, value2
       logical inquirefile
-      character*1 answr, cdata1(nwrds1)
+      character*1 answr, cdata1(nwrds1), string
       real*8 rmax2, rmax4, rmax1, rdata8(nwrds8), dnan, d_quiet_nan
 c
       parameter (rmax1 = 255.0d0)
@@ -69,7 +69,7 @@
       endif
 c
       ilen = lastblnk(dirprefix(1))
-      headname = dirprefix(1)(1:ilen) // '/sunbin/twodim.mask'
+      headname = dirprefix(1)(1:ilen) // '/bin/twodim.mask'
 c     Get the file name of FITS template file
 c
       open(unit=iiotmp,file=headname,access='sequential',
@@ -127,9 +127,9 @@
       endif
 c     Calculate max,min, and scale factors from min/max in matrix 0.
 c
-      write(unit=hmask(2) (24:30),20,iostat=ierr) nint(mhead(mbitpix,1))
-      write(unit=hmask(4) (24:30),20,iostat=ierr) nint(mhead(mnaxis1,1))
-      write(unit=hmask(5) (24:30),20,iostat=ierr) nint(mhead(mnaxis2,1))
+      write(hmask(2) (24:30),20,iostat=ierr) nint(mhead(mbitpix,1))
+      write(hmask(4) (24:30),20,iostat=ierr) nint(mhead(mnaxis1,1))
+      write(hmask(5) (24:30),20,iostat=ierr) nint(mhead(mnaxis2,1))
 20    format(i7)
 c
       hmask(6) (12:19) = cmhead(mtype1,1)
@@ -145,27 +145,27 @@
       hmask(16) (nend:nend) = '\''
       hmask(20) (12:19) = cmhead(mbunit,1)
 c
-      write(unit=hmask(7) (15:30),40,iostat=ierr) mhead(mrval1,1)
-      write(unit=hmask(8) (15:30),40,iostat=ierr) mhead(mdelt1,1)
-      write(unit=hmask(9) (15:30),40,iostat=ierr) mhead(mpix1,1)
-      write(unit=hmask(11) (15:30),40,iostat=ierr) mhead(mrval2,1)
-      write(unit=hmask(12) (15:30),40,iostat=ierr) mhead(mdelt2,1)
-      write(unit=hmask(13) (15:30),40,iostat=ierr) mhead(mpix2,1)
+      write(hmask(7) (15:30),40,iostat=ierr) mhead(mrval1,1)
+      write(hmask(8) (15:30),40,iostat=ierr) mhead(mdelt1,1)
+      write(hmask(9) (15:30),40,iostat=ierr) mhead(mpix1,1)
+      write(hmask(11) (15:30),40,iostat=ierr) mhead(mrval2,1)
+      write(hmask(12) (15:30),40,iostat=ierr) mhead(mdelt2,1)
+      write(hmask(13) (15:30),40,iostat=ierr) mhead(mpix2,1)
       if (nint(mhead(mbitpix,1)) .eq. 16) then
-        write(unit=hmask(17) (15:30),42,iostat=ierr) (blankfits2-1)
+        write(hmask(17) (15:30),42,iostat=ierr) (blankfits2-1)
       else if (nint(mhead(mbitpix,1)) .eq. 32) then
-        write(unit=hmask(17) (15:30),42,iostat=ierr) (blankfits4-1)
+        write(hmask(17) (15:30),42,iostat=ierr) (blankfits4-1)
       else if (nint(mhead(mbitpix,1)) .eq. 8) then
-        write(unit=hmask(17) (15:30),42,iostat=ierr) blankfits1
+        write(hmask(17) (15:30),42,iostat=ierr) blankfits1
       else if (nint(mhead(mbitpix,1)) .lt. 0) then
-        write(unit=hmask(17), 45,iostat=ierr) ' '
+        write(hmask(17), 45,iostat=ierr) ' '
       else
 	call oerror(n273, m1, 'MWRITE: Bad MBITPIX')
       endif
-      write(unit=hmask(18) (15:30),40,iostat=ierr) tscale
-      write(unit=hmask(19) (15:30),40,iostat=ierr) tzero
-      write(unit=hmask(21) (15:30),40,iostat=ierr) zmin
-      write(unit=hmask(22) (15:30),40,iostat=ierr) zmax
+      write(hmask(18) (15:30),40,iostat=ierr) tscale
+      write(hmask(19) (15:30),40,iostat=ierr) tzero
+      write(hmask(21) (15:30),40,iostat=ierr) zmin
+      write(hmask(22) (15:30),40,iostat=ierr) zmax
       if (cmhead(mtype1,1)(1:4) .eq. 'RA--' .or.
      .    cmhead(mtype2,1)(1:4) .eq. 'RA--' .or.
      .    cmhead(mtype1,1)(1:4) .eq. 'HA--' .or.
@@ -173,7 +173,7 @@
      .    cmhead(mtype1,1)(1:4) .eq. 'DEC-' .or.
      .    cmhead(mtype2,1)(1:4) .eq. 'DEC-') then
          if (mhead(mequinox,1) .eq. 0) mhead(mequinox,1) = 1950.0
-         write(unit=hmask(23) (15:30),40,iostat=ierr) mhead(mequinox,1)
+         write(hmask(23) (15:30),40,iostat=ierr) mhead(mequinox,1)
          hcmt = 24
       else
          do 102 i = 23, 34
@@ -242,7 +242,7 @@
 c	last record.
 c
 	do 91 i = 1, j
-	   i4 = long(i) + nwrds*long(irec-2)
+	   i4 = int(i) + nwrds*int(irec-2)
 	   if (nint(mhead(mbitpix,1)) .eq. 16) then
 	   	if (mdata(i4) .eq. sngl(mhead(mblank,1))) then
 			ldata2(i) = blankfits2 - 1
@@ -259,7 +259,9 @@
 	   	if (mdata(i4) .eq. sngl(mhead(mblank,1))) then
 			cdata1(i) = char(blankfits1)
 	   	else
-	        	cdata1(i) = char((mdata(i4)-tzero)/tscale)
+                        value2=(mdata(i4)-tzero)/tscale
+                        write(string,'(i1)'),value2
+	        	cdata1(i) = string
 	   	endif
 	   else if (nint(mhead(mbitpix,1)) .eq. -32) then
 	   	if (mdata(i4) .eq. sngl(mhead(mblank,1))) then
diff -uNr 3.5/source/conline/line/plot.f unipops-3.6/source/conline/line/plot.f
--- 3.5/source/conline/line/plot.f	2000-03-16 11:35:22.000000000 -0700
+++ unipops-3.6/source/conline/line/plot.f	2008-12-29 14:39:27.000000000 -0700
@@ -8,17 +8,17 @@
       include 'core.inc'
       include 'appl.inc'
 c
-      integer*2 nchan, iplt, ix, i, ipuf(4), ilen, lastblnk, ier, iy,
+      integer*2 nchan, iplt, ix, i, ipuf(4), ilen, lastblnk, iy,
      .		short, mint, idely, nxl, nyl, itemp, ipixel, sclc, idelx
       integer*2 m2, n1, n2, n5, n8, n12, n14, n20, n30, n33, 
      .          n55, n219, n220, n10, curcur, npp1
       character*10 getformat, format
-      integer*4 ibx, iby, ix4, iy4
+      integer*4 ibx, iby, ix4, iy4, ier
       character*8 cpuf
       character*2 ctemp
-      real*4 ybtm, ytop, ylog, yval, dy, ymax1, ylow2, fupy, xmx, xmn,
+      real*4 ybtm, ytop, yval, dy, ymax1, ylow2, fupy, xmx, xmn,
      .	     fy1, dfy1, ymax2, ymin1, fy2, dfy2, ymin2, yf, yl
-      real*4 xlft, xrght, xlog, xval, dx, xmax1,xlow2, fupx, ymn, ymx,
+      real*4 xlft, xrght, xval, dx, xmax1,xlow2, fupx, ymn, ymx,
      .	     fx1, dfx1, xmax2, xmin1, fx2, dfx2, xmin2, xf, xl, aa
       logical okreal4, placenxt
 c
diff -uNr 3.5/source/conline/line/posstring.f unipops-3.6/source/conline/line/posstring.f
--- 3.5/source/conline/line/posstring.f	2000-03-16 11:35:24.000000000 -0700
+++ unipops-3.6/source/conline/line/posstring.f	2008-12-29 14:39:27.000000000 -0700
@@ -52,9 +52,9 @@
 c
       return
 C---------------------------------------------------------------
- 1000 format(2x,i2.2,x,i2.2,x,'0',f3.1)
- 1005 format(2x,i2.2,x,i2.2,x,f4.1)
- 1010 format(2x,i2.2,x,i2.2,x,i2.2,2x)
+ 1000 format(2x,i2.2,1x,i2.2,1x,'0',f3.1)
+ 1005 format(2x,i2.2,1x,i2.2,1x,f4.1)
+ 1010 format(2x,i2.2,1x,i2.2,1x,i2.2,2x)
  1020 format(a1)
- 1030 format(x,f8.4,3x)
+ 1030 format(1x,f8.4,3x)
       end
diff -uNr 3.5/source/conline/line/readcube.f unipops-3.6/source/conline/line/readcube.f
--- 3.5/source/conline/line/readcube.f	2000-03-16 11:35:27.000000000 -0700
+++ unipops-3.6/source/conline/line/readcube.f	2008-12-29 14:39:27.000000000 -0700
@@ -10,12 +10,13 @@
       character*1023 headname, fullname
       character*1 quote
       logical lend, inquirefile
-      integer*2 ierr, j, i, ilen, irec, nv, kmax, maxrec, mleft, 
+      integer*2 j, i, ilen, irec, nv, kmax, maxrec, mleft, 
      .		istch(40), lastblnk, k, blankfits2, blankfits1
       integer*2 m1, m2, n80, n352, n357, n365
       integer*4 n1, n2, n3, nwrds2, nwrds4, nwrds1, nwrds8, blankfits4
-      integer*4 nchars, oldfits, bp, iblank, ii
-      real*8 rmax1, rmax2, rmax4
+      integer*4 ierr, nchars, oldfits, bp, iblank, ii
+      character*8 string
+      real*8 rmax1, rmax2, rmax4, value
       real r_quiet_nan
 c
       include 'mappl.inc'
@@ -23,6 +24,8 @@
       include 'mform.inc'
 c
       equivalence (istch,stch)
+c     we need this equivalence, because g77 can't declare chars as reals
+      equivalence (string, value)
 c
       parameter (rmax1 = 255.0d0)
       parameter (rmax2 = 32767.0d0)
@@ -35,6 +38,7 @@
       parameter (blankfits2 = -32767)
       parameter (blankfits1 = 1)
 c
+      data string /'        '/
       data m1, m2, n80, n352, n357, n365 /-1, -2, 80, 352, 357, 365/
       data quote /''''/
 c
@@ -87,19 +91,21 @@
       chead(cpix2) = 1.
       chead(cpix3) = 1.
       chead(cequinox) = 0.0
-      chead(ctype1) = '        '
-      chead(ctype2) = '        '
-      chead(ctype3) = '        '
+c     g77 needs explicit type conversion via internal file ops
+c     (see equivalence at beginning of subroutine) -CAK
+      chead(ctype1) = value
+      chead(ctype2) = value
+      chead(ctype3) = value
       chead(cdate) = -1.0
-      chead(cobject) = '        '
-      chead(cobject+1) = '        '
-      chead(corigin) = '        '
-      chead(cbunit) = '        '
+      chead(cobject) = value
+      chead(cobject+1) = value
+      chead(corigin) = value
+      chead(cbunit) = value
       do 1011 i = 1, cheadsize-ccomment+1
 	cchead(i-1+ccomment) = '        '
 1011	continue
 c     Sets up defaults if the header doesn't contain the necessary
-c     information.  No gaurentees if one of the above is not in the header
+c     information.  No garantees if one of the above is not in the header
 c
       irec = 0
 c
@@ -130,7 +136,7 @@
 	if (head(2)(1:10) .ne. hmask(2)(1:10)) then
      	   call oerror(n365, m2, 'READCUBE: ----> '// head(2)(1:30))
 	else
-	   read(unit=head(2) (11:30), fmt=20, iostat=ierr) nv
+	   read(head(2) (11:30), fmt=20, iostat=ierr) nv
 	   chead(cbitpix) = nv
 	endif
 c
@@ -147,20 +153,20 @@
 	if (head(4)(1:10) .ne. hmask(4)(1:10)) then
      	   call oerror(n365, m2, 'READCUBE: ----> '// head(4)(1:30))
 	else
-	   read(unit=head(4) (11:30),fmt=20, iostat=ierr) nv
+	   read(head(4) (11:30),fmt=20, iostat=ierr) nv
 20    	   format(i20)
 	   chead(cnaxis1) = nv
 	endif
 	if (head(5)(1:10) .ne. hmask(5)(1:10)) then 
      	   call oerror(n365, m2, 'READCUBE: ----> '// head(5)(1:30))
 	else
-	   read(unit=head(5) (11:30),fmt=20, iostat=ierr) nv
+	   read(head(5) (11:30),fmt=20, iostat=ierr) nv
 	   chead(cnaxis2) = nv
 	endif
 	if (head(6)(1:10) .ne. hmask(6)(1:10)) then 
      	   call oerror(n365, m2, 'READCUBE: ----> '// head(6)(1:30))
 	else
-	   read(unit=head(6) (11:30),fmt=20, iostat=ierr) nv
+	   read(head(6) (11:30),fmt=20, iostat=ierr) nv
 	   chead(cnaxis3) = nv
 	endif
 c       Checks NAXIS1,NAXIS2,NAXIS3
@@ -207,22 +213,22 @@
                 endif
 		if (i .eq. 29) cchead(cbunit) = head(j) (12:19) 
 c
-      		if (i.eq.8) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i.eq.8) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(crval1)
-      		if (i.eq.9) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i.eq.9) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(cdelt1)
-		if (i.eq.10) read(unit=head(j)(11:30),40) chead(cpix1)
-      		if (i .eq. 13) read(unit=head(j)(11:30),40,iostat=ierr) 
+		if (i.eq.10) read(head(j)(11:30),40) chead(cpix1)
+      		if (i .eq. 13) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(crval2)
-      		if (i .eq. 14) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i .eq. 14) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(cdelt2)
-		if (i .eq. 15) read(unit=head(j)(11:30),40,iostat=ierr) 
+		if (i .eq. 15) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(cpix2)
-      		if (i .eq. 18) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i .eq. 18) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(crval3)
-      		if (i .eq. 19) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i .eq. 19) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(cdelt3)
-		if (i .eq. 20) read(unit=head(j)(11:30),40,iostat=ierr) 
+		if (i .eq. 20) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(cpix3)
       		if (i .eq. 26) then 
 c                       look for bad unipops BLANK values which may be
@@ -231,21 +237,21 @@
                       if (head(j)(ii:ii) .eq. '.') goto 410
  405               continue
  410               if  (ii .le. 30) then
-                      read(unit=head(j)(11:30),45,iostat=ierr) fcblank
+                      read(head(j)(11:30),45,iostat=ierr) fcblank
                    else
-                      read(unit=head(j)(15:30),45,iostat=ierr) iblank
+                      read(head(j)(15:30),45,iostat=ierr) iblank
                       fcblank = iblank
                    endif
                 endif
-      		if (i .eq. 27) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i .eq. 27) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(ctscale)
-      		if (i .eq. 28) read(unit=head(j)(11:30),40,iostat=ierr)
+      		if (i .eq. 28) read(head(j)(11:30),40,iostat=ierr)
      .							chead(ctzero)
-      		if (i .eq. 30) read(unit=head(j)(11:30),40,iostat=ierr) 
+      		if (i .eq. 30) read(head(j)(11:30),40,iostat=ierr) 
      .							chead(ctmin)
-      		if (i .eq. 31) read(unit=head(j) (11:30),40,iostat=ierr) 
+      		if (i .eq. 31) read(head(j) (11:30),40,iostat=ierr) 
      .							chead(ctmax)
-      		if (i .eq. 32) read(unit=head(j) (11:30),40,iostat=ierr) 
+      		if (i .eq. 32) read(head(j) (11:30),40,iostat=ierr) 
      .							chead(cequinox)
  40             format(1g20.0)
  45             format(i16)
diff -uNr 3.5/source/conline/line/savebyloc.f unipops-3.6/source/conline/line/savebyloc.f
--- 3.5/source/conline/line/savebyloc.f	2000-03-16 11:35:31.000000000 -0700
+++ unipops-3.6/source/conline/line/savebyloc.f	2008-12-29 14:39:27.000000000 -0700
@@ -20,7 +20,7 @@
       logical*2 overwrite
       integer*2 imagic, iunit, ierr, n0, n80, n120, n355, m3, ier, iloc
       integer*4 lunit, loverwrite, lrtn, j
-      double precision array(*), location, obsmode, ydata(2786)
+      double precision array(*), location, obsmode, ydata(4096)
 c
       equivalence (obsmode, cobsmode)
 c
@@ -28,16 +28,16 @@
 c
       include 'cform.inc'
 c
-      lunit = iunit
-      location = iloc
+      lunit = int(iunit)
+      location = dble(iloc)
       loverwrite = 0
       if (overwrite) loverwrite = 1
       ierr = 0
-c			make sure data_length is large enough
+c     make sure data_length is large enough
       if (array(c1dln).lt.(array(c12ni) + array(c12spn) - 1) * 4.0) then
          array(c1dln) = (array(c12ni) + array(c12spn) - 1) * 4.0
       endif
-c			convert, pass address of array and ydata to saveascan
+c     convert, pass address of array and ydata to saveascan
       call conversion3(array, ydata, ier)
       if (ier .lt. 0) then
          ierr = 360
@@ -87,7 +87,7 @@
  99   return
 c
  40   format('Unrecognized observing mode ',4a1)
- 50   format('Unknown error code ', i)
- 60   format('Data exists at ', i,' .... Overwriting!')
+ 50   format('Unknown error code ', i1)
+ 60   format('Data exists at ', i1,' .... Overwriting!')
 c
       end
diff -uNr 3.5/source/conline/line/savebynum.f unipops-3.6/source/conline/line/savebynum.f
--- 3.5/source/conline/line/savebynum.f	2000-03-16 11:35:32.000000000 -0700
+++ unipops-3.6/source/conline/line/savebynum.f	2008-12-29 14:39:27.000000000 -0700
@@ -20,7 +20,7 @@
       logical*2 overwrite
       integer*2 imagic, iunit, ierr, n0, n80, n120, n355, m3, ier
       integer*4 lunit, loverwrite, lrtn, j
-      double precision array(*), scan, location, obsmode, ydata(2786)
+      double precision array(*), scan, location, obsmode, ydata(4096)
 c
       equivalence (obsmode, cobsmode)
 c
@@ -85,9 +85,9 @@
 c
  99   return
 c
- 10   format('Unexpected error code ',i)
+ 10   format('Unexpected error code ',i1)
  40   format('Unrecognized observing mode ',4a1)
- 50   format('Unknown error code ', i)
+ 50   format('Unknown error code ', i1)
  60   format('Scan ',f12.2,' exists .... Overwriting!')
 c
       end
